<?php
defined('_JEXEC') or die;
class plgVm2smsTargetsms_send_js4
{
        private $login;
        private $pass;
        private $security;
        private $sender;
        private $url = 'https://sms.targetsms.ru/sendsmsjson.php';

		function __construct($params = array()) {
            $login = $params['targetsms_login'];
			$password = $params['targetsms_pass'];
            $this->security = array('login'=>$login,'password'=>$password);
            $this->sender = (!empty($params['targetsms_sender'])?$params['targetsms_sender']:'targettele');
		}
       
       public function prepareText($text,$order,$params){
        $jshopConfig = JSFactory::getConfig();
        $order_number = $order['order_number'];
        $customer_phone = $order[$params['phone_field']];
        if (empty($customer_phone) && $order['phone'] ) $customer_phone = $order['phone'];
        if (empty($customer_phone) && $order['mobil_phone'] ) $customer_phone = $order['mobil_phone'];
        $order_total = $order['order_total'];
        $order_total = formatprice($order_total, $order['currency_code']);
        $customer_name = $order['f_name'];
        if (isset($order['l_name']) && !empty($order['l_name'])) $customer_name .=' '.$order['l_name'];
        
        $customer_email = $order['email'];
        
        $text = str_replace(['{ORDER_NUMBER}', '{PHONE_NUMBER}'], [$order_number, $customer_phone], $text);
                
                $text = str_replace('{ORDER_TOTAL}', $order_total, $text);
                $text = str_replace('{FULLNAME}', $customer_name, $text);
                $text = str_replace('{ORDER_STATUS}', $order['state'], $text);
                $text = str_replace('{EMAIL}', $customer_email, $text);
        return $text;
       }

    public function prepareSMS($order,$status){
        $params = JComponentHelper::getParams('com_jshoppingtsms');
        $language   = JFactory::getLanguage();
        $locale     = $language->getTag();
        $order = (array)$order;
        $admin_phone = $params['targetsms_phone'];
        $customer_phone = $order[$params['phone_field']];
        if (empty($customer_phone) && $order['phone'] ) $customer_phone = $order['phone'];
        if (empty($customer_phone) && $order['mobil_phone'] ) $customer_phone = $order['mobil_phone'];
        // берём сообщения для статуса        
        $db = JFactory::getDBO();		
		$db->setQuery('SELECT sms.*, so.`name_'.$locale.'` as order_status_name FROM #__jshoppingtsms as sms left join #__jshopping_order_status so on sms.status = so.status_id where sms.status = '.$status);// 
		$sms_array = $db->loadObjectList();
        
        if (is_array($sms_array)){
            foreach($sms_array as $sms_data){
                $order['state'] = $sms_data->order_status_name;
                if ($sms_data->send_sms==1){
                    $mess = $this->prepareText($sms_data->text_sms,$order,$params);
                    if ($this->CheckPhoneNumber($customer_phone) && !empty($mess))                        $this->send($customer_phone,$mess);
                }
                if ($sms_data->manager_send_sms==1){
                    $mess = $this->prepareText($sms_data->manager_text_sms,$order,$params);
                    if ($this->CheckPhoneNumber($admin_phone) && !empty($mess))                        $this->send($admin_phone,$mess);
                }
            }
        }
	   return null;
    }

 	public function send($phone, $mess)
	{
	   
	   $sender = $this->sender;
       $abonent[] = array(
                'phone' => (string)$phone,
                'number_sms' => '1'
            ); 
            $params['message'][] = array(
                 'type' => 'sms',
                 'sender' => $sender,
                 'text' => $mess,
                 'name_delivery'=>'joomla_joomshopping',
                 //'translite' => $settings['translite'],
                 'abonent' => $abonent
                 );
    
            $sms = $this->send_one($params);
            //print_r($sms);
			//return $sms;
            if ($sms['action'] == "send") return true;
					else {
						//JFactory::getApplication()->enqueueMessage('Error sending sms: '.$result['error'],'error');
                        return false;
					}
	}



  /**
   * Получение состояния баланса
   */
  public function getBalance() {
    
    $res = $this->Request('balance');
    //$res = $this->CheckReplyError($request, 'getBalance');
    
    if (isset($res['error'])){
        return $res['error'];
    } else {
        return $res['money']['value'].' руб.';
        
    }
  }


// ВНУТРЕННИЕ ФУНКЦИИ
  public function send_one($post) {    
    $request = $this->Request('sms', $post);
    $resp = $request;
    //wa_dump($resp);
    $res = array();
    if ($resp && is_array($resp)){
        foreach($resp as $result){
            $res = $result[0];
        }
    }
    if (isset($resp['error'])) {
        $res = $resp;
        $res['action']='error';
    }
    return $res;
  }
// Функция вызова запроса. Формирует URL и делает 3 попытки чтения

  private function Request($type, $params = array()) {
    
    $params['security'] = $this->security;
    $params['type'] = $type;
    
    $param_json = json_encode($params, true);
    $href = $this->url;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
    curl_setopt($ch, CURLOPT_TIMEOUT, 600);
    curl_setopt($ch, CURLOPT_URL, $href);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
    $res = curl_exec($ch);
    $result = json_decode($res, true);
    curl_close($ch);
    return $result;
  }



	public function CheckPhoneNumber($phone)
	{
		$result = true;
		$phone = str_replace('+', '', $phone);
		$phone = preg_replace('/\s+/', '', $phone);
		if (!preg_match("/^[0-9]{11,14}+$/", $phone)) {
			//if (isset($this)) $this->error = GetMessage(JText::_("TARGETSMS_SMS_WRONG_PHONE")).$phone;
			$result = false;
		}

		return $result;
	}

	
}